SystemOrganization addCategory: #ConfigurationOfLateClassBinding!

Object subclass: #ConfigurationOfLateClassBinding
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLateClassBinding'!

!ConfigurationOfLateClassBinding commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfLateClassBinding class methodsFor: 'development support' stamp: 'mt 7/16/2013 11:19:59.72'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfLateClassBinding class methodsFor: 'private' stamp: 'mt 7/16/2013 11:19:59.891'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLateClassBinding class methodsFor: 'private' stamp: 'mt 7/16/2013 11:19:59.977'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLateClassBinding class methodsFor: 'private' stamp: 'mt 7/16/2013 13:26:39.878'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemtalksystems.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLateClassBinding class methodsFor: 'metacello tool support' stamp: 'mt 7/16/2013 11:20:00.149'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLateClassBinding class methodsFor: 'loading' stamp: 'mt 7/16/2013 11:20:00.235'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfLateClassBinding class methodsFor: 'loading' stamp: 'mt 7/16/2013 11:20:00.321'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfLateClassBinding class methodsFor: 'loading' stamp: 'mt 7/16/2013 11:20:00.408'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfLateClassBinding class methodsFor: 'accessing' stamp: 'mt 7/16/2013 11:25:55.491'!
project

	^self new preLoad project! !

!ConfigurationOfLateClassBinding class methodsFor: 'development support' stamp: 'mt 7/16/2013 11:19:59.805'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLateClassBinding methodsFor: 'baselines' stamp: 'mt 7/16/2013 13:35:28.918'!
baseline100: spec
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/ClassLateBinding'.
		
		spec project: 'OmniBrowser' with: [
			spec
				className: 'ConfigurationOfOmniBrowser';
				loads: #('Core');
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		
		spec project: 'Signals' with: [
			spec
				className: 'ConfigurationOfSignals';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].
			
		spec
			package: 'LateClassBinding' with: [spec requires: #('Signals')];
			package: 'Kernel' with: [spec requires: #('LateClassBinding')];
			package: 'Tools' with: [spec requires: #('Kernel')];
			package: 'System' with: [spec
				requires: #('Kernel');
				postLoadDoIt: #postLoad];
			package: 'OB-LateClassBinding' with: [spec requires: #('LateClassBinding')].
			
		spec
			group: 'default' with: #('core');
			group: 'core' with: #('LateClassBinding' 'Kernel' 'Tools' 'System');
			group: 'ob' with: #('core' 'OB-LateClassBinding').
		].! !

!ConfigurationOfLateClassBinding methodsFor: 'accessing' stamp: 'mt 7/16/2013 11:19:59.55'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfLateClassBinding methodsFor: 'symbolic versions' stamp: 'mt 7/16/2013 11:42:55.099'!
development: spec 
	<symbolicVersion: #development>
	
	spec for: #'common' version: '2.0.0'.! !

!ConfigurationOfLateClassBinding methodsFor: 'as yet unclassified' stamp: 'mt 7/16/2013 13:13:11.939'!
postLoad

	#(ProcessSpecificTest LateClassBinding) do: [:className |
		Transcript cr; show: '[LateClassBinding] Recompiling important classes...'.
		(Smalltalk at: className) compileAll].! !

!ConfigurationOfLateClassBinding methodsFor: 'pre-/postload' stamp: 'mt 7/16/2013 11:25:08.616'!
preLoad

	| privatePackages loginData |
	privatePackages := Dictionary newFrom: {
		#'LateClassBinding' -> #('http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/' 'ClassLateBinding').
		#'Kernel' -> #('http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/' 'ClassLateBinding').
		#'Tools' -> #('http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/' 'ClassLateBinding').
		#'System' -> #('http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/' 'ClassLateBinding')}.
	loginData := Dictionary new.
		
	privatePackages keysAndValuesDo: [:packageName :location |
		(MCPackage named: packageName) workingCopy repositoryGroup ifNotNil: [:group |
			(group repositories anySatisfy: [:repo | repo isKindOf: MCHttpRepository]) ifFalse: [
				loginData at: location first ifAbsentPut: [
					(UIManager default request: 'User (Squeaksource @ HPI)') -> (UIManager default requestPassword: 'Password (Squeaksource @ HPI)')].
				group addRepository: (MCHttpRepository
					location: location first, location second
					user: (loginData at: location first) key
					password: (loginData at: location first) value)]]].! !

!ConfigurationOfLateClassBinding methodsFor: 'accessing' stamp: 'mt 7/16/2013 11:19:59.634'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLateClassBinding methodsFor: 'symbolic versions' stamp: 'mt 7/16/2013 11:41:55.863'!
stable: spec 
	<symbolicVersion: #stable>
	
	"squeak 4.4"
	spec for: #'squeak4.x' version: '1.0.0'.! !

!ConfigurationOfLateClassBinding methodsFor: 'versions' stamp: 'mt 7/16/2013 13:37:27.208'!
version100: spec
	<version: '1.0.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Stephi Platz'.
		
		spec
			project: 'OmniBrowser' with: '1.1.5';
			project: 'Signals' with: '1.0.8'.
		
		spec
			package: 'LateClassBinding' with: 'LateClassBinding-sp.63';
			package: 'OB-LateClassBinding' with: 'OB-LateClassBinding-sp.1';
			package: 'Kernel' with: 'Kernel-sp.728';
			package: 'Tools' with: 'Tools-sp.432';
			package: 'System' with: 'System-sp.512'.]! !

!ConfigurationOfLateClassBinding methodsFor: 'versions' stamp: 'mt 7/16/2013 13:35:53.881'!
version200: spec
	<version: '2.0.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Stephi Platz'.
		
		spec
			project: 'OmniBrowser' with: #stable;
			project: 'Signals' with: #stable.
		
	"	spec
			package: 'LateClassBinding' with: 'LateClassBinding-sp.62';
			package: 'OB-LateClassBinding' with: 'OB-LateClassBinding-sp.1';
			package: 'Kernel' with: 'Kernel-sp.728';
			package: 'Tools' with: 'Tools-sp.432';
			package: 'System' with: 'System-sp.512'."]! !
